
(Présentation générale du niveau Chomsky 1 : grammaire contextuelle, allocation de mémoire
 (Chomsky 1 : positionnement théorique
  (Conventions de notation
   (Nous noterons ce niveau Chomsky 1 : '∫k1+ctxt' et plus simplement : ∫k1.) ) 
  (∫k1 introduit la notion de contexte, abrégé en ctxt
   (Les grammaires contextuelles sont reconnues par un automate linéairement borné... Mais en fait nous délaisserons cet aspect théorique.)
   (Et, à propos de contexte, nous focaliserons sur un autre aspect : la notion d' "empilement de contextes imbriqués". §/contxt/a.png) ) 
  (Héritage : ∫k1 relève de ∫k2+rtr
   (Donc il hérite de ses aptitudes. Sachant que 'rtr' est l'abréviation de "réseau de transition récursif", alors ∫k1 est lui aussi récursif.)
   (∫k1 anime de nombreux agents composés² sur un support : 
    (Pour les représenter il est pratique d'utiliser une représentation sagittale. Ex de trois relations : §/netSémantiq/4objCla∫ic.png)
    (En effet, on délaisse la table réflexive, de la forme M ℜ M, qui se creuse quand les agents sont nombreux. Ex : §/rela°/cuisine.png) ) ) ) 
 (Décrire les traits principaux de ∫k1
  (Le trait "grammaire contextelle"
   (Tout d'abord : un peu de vocabulaire
    (L'affectation : c'est le fait de donner une valeur à une variable. §/contxt/var-val.png)
    (Ce faisant on obtient une lien var→val. §/variable/var→val.png)
    (Un contexte consiste en un ensemble de un ou plusieurs liens variable→valeur.
     (Exemple d'un contexte à une variable : ici ctxt = {couleur} §/machiPapi/5arithmé/1Ev1Expr1aire/évalVar.png)
     (Exemple d'un contexte à deux variables : ici ctxt = {prix_unité, nombre} §/machiPapi/callFonc°/évalPrixD1Lot.png) ) ) 
   (∫k1 permet l'utilisation de "contextes locaux imbriqués".
    (Exemple de contexte imbriqué inspiré du TAL ⊈Traitement Automatique du Langage⊉ : §/contxt/txt.png) ) 
   (Implémentation d'une machine utilisant les contextes imbriqués
    (Elle se fait tout simplement au moyen d'une pile LIFO ⊈last in first out⊉. §/pileDAssiettes/liFo.png
     (Implémentation des fonctions basiques pour utiliser une pile :
      (push : §/piles/PushA.png)
      (pop : §/piles/PopA.png) ) ) 
    (Le fait que les contextes soient empilés fait que, chaque contexte poussé dans la pile voit ceux qui ont été empilés avant lui.
     (Ainsi le dernier contexte poussé dans la pile voit tous les autres avant lui, càd sur la gauche. Regarder le dessin de l'œil tout à droite. §/contxt/txt.png)
     (De même, le contexte global ⊈le premier contexte⊉, apparaît comme le premier des contextes locaux. C'est ainsi qu'il est visible de tous.) ) 
    (Dans une boucle, Lisp, qui est un langage récursif empile presque le même contexte, càd les mêmes variables, mais avec des valeurs différentes.
     (Quand on l'évalue, une variable prend la valeur qu'elle a, dans le contexte où elle est évaluée. Ex avec fact en lisp : §/lisp/exec/nice1.png) ) ) ) 
  (La réservation dynamique de mémoire ⊈symboliquement : malloc = memory alloc⊉ §/chomsky/moy.png
   (Comparer l'utilisation de l'espace mémoire entre ∫k 1 et 2
    (∫k2 est fini². Il permet une représentation des données au moyent de tableaux STATIQUES :
     (C'est une structure de données simple mais rigide : l'espace mémoire qui lui est consacré est réservé, une fois pour toute, au démarrage du programme. )
     (Donc le risque est de ne pas en réserver assez et d'avoir, au cours de l'exécution, un problème de débordement ⊈overflow⊉.) ) ) 
   (Cette aptitude, très importante, marque la frontière entre ∫k1 et ∫k2. On la nomme aussi allocation dynamique. §/chomsky/moy.png
    (En effet, au cours d'un programme, pour traiter une formule expansive, le codeur doit pouvoir allouer de la mémoire aux structures de données qui grandissent à mesure qu'on les traite.
     (Ex 1 : en maths : la dérivation d'un produit des fonctions U⊈x⊉*V⊈x⊉ : [UV]' = U'V +UV'.)
     (Ex 2 : en informatique, l'évaluation d'un appel de fonction : il faut expanser la forme d'appel par sa fonction : carré⊈x⊉ → x*x. §/machiPapi/callFonc°/carréN.png)
     (Ex 3 : l'allocation dynamique permet à ∫k1 de traiter les formes expansives de la forme : S1 → ⊈S2 S3⊉
      (Explicitons cette formule un peu dense : les Si sont des symboles.
       (La structure de données ⊈S2 S3⊉ est une liste qui contient deux éléments : S1 et S2. )
       (La chose se lit : le symbole S1 se réécrit en une liste de deux symboles : S2 et S3.) ) ) ) ) 
   (Avec ∫k1, le Malloc donne de la souplesse au procès et permet à l'agent d'enrichir, à l'envie, les descriptions qu'il fait de son monde.
    (Ainsi, il peut représenter ses connaissances à propos du monde, au moyen de supports souples et riches : ⊈graphes⊉ mais surtout listes, arbres. §/parse/c.png) ) ) ) 
 (Conclusion : vu ses aptitudes, ∫k1 est le domaine des L3G+ ⊈langages structurés de la 3ème génération⊉
  (ici voir programming language history)
  (∫k1+ctxt : en utilisant la pile héritée de ∫k2 pour implémenter les contextes imbriqués on implémente un langage de programmation structuré
   (Nous disposons déjà d'une pile venue de ∫k2 où elle implémente la récursivité des RTR.)
   (En l'utilisant pour implémenter des contextes locaux imbriqués on obtient un langage de programmation structuré
    (En effet, en empiliant ou dépilant les liaisons var→val des contextes, on implémente des contextes locaux imbriqués. ) ) 
   (En représentant les procès sous forme d'arbre on dispose d'un langage structuré.
    (On avait déjà la pile de rtr, maintenant on peut y passer des variables : on a la récursivité. )
    (On avait le Malloc et avec cette disposition maintenant on dispose de la notation arborescente.) ) 
   (∫k1 permet donc d'implémenter un langage de programmation contextuel et structuré.
    (Ainsi il possède la puissance de traitement des L3G+ ⊈langages structurés de la 3ème génération⊉ : lisp C Pascal...) ) ) ) ) 